openapi: 3.0.1
info:
  description: OpenAPI definition for the User and Roles component of the SIMPL project
  license:
    name: European Union Public License (EUPL) 1.2
    url: https://interoperable-europe.ec.europa.eu/sites/default/files/custom-page/attachment/eupl_v1.2_en.pdf
  title: User and Roles OpenAPI definition
  version: 1.1.1
servers:
- description: usersroles
  url: /v1
tags:
- description: API for managing Users
  name: Users
- description: API for managing Roles
  name: Roles
- description: API for managing Sessions
  name: Sessions
- description: API for managing Mtls
  name: Mtls
- description: API for managing Credentials
  name: Credentials
- description: API for managing Identity Attributes
  name: Identity Attributes
- description: API for managing Agents
  name: Agents
- description: API for managing Public Keys of the Identity and Access Manager
  name: Public Keys
paths:
  /users/{userId}:
    delete:
      description: Deletes a user by its UUID
      operationId: deleteUser
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: userId
        required: true
        schema:
          type: string
        style: simple
      responses:
        "204":
          description: User deleted successfully
        "400":
          description: Invalid UUID format
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      security:
      - oauth2AuthCode: []
      summary: Delete user
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
    get:
      description: Retrieves a user by its UUID
      operationId: getUserByUuid
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: userId
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KeycloakUser'
          description: Successfully retrieved user
        "400":
          description: Invalid UUID format
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      security:
      - oauth2AuthCode: []
      summary: Get user by UUID
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
    put:
      description: Updates the details of an existing user by its UUID
      operationId: updateUser
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: userId
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakUser'
        description: The user details to update
        required: true
      responses:
        "200":
          description: User updated successfully
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      security:
      - oauth2AuthCode: []
      summary: Update user
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
  /users/{userId}/roles:
    get:
      description: Retrieves the roles associated with a user by its UUID
      operationId: getRoles
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: userId
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/KeycloakRole'
                type: array
          description: Successfully retrieved user roles
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      security:
      - oauth2AuthCode: []
      summary: Get user roles
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
    put:
      description: Updates the roles associated with a user by its UUID
      operationId: updateUserRoles
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: userId
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              items:
                type: string
              type: array
        description: The list of roles to be assigned to the user
        required: true
      responses:
        "200":
          description: User roles updated successfully
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      security:
      - oauth2AuthCode: []
      summary: Update user roles
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
  /roles:
    get:
      description: Searches for roles based on the provided filter criteria and pagination
        settings
      operationId: searchRoles
      parameters:
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 10
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          default:
          - "id,ASC"
          items:
            type: string
          type: array
        style: form
      - in: query
        name: filter
        schema:
          $ref: '#/components/schemas/searchRoles_filter_parameter'
        x-parameter-object: true
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PageResponseRole'
          description: Successfully retrieved the list of roles
        "400":
          description: Invalid filter or pagination parameters
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2AuthCode: []
      summary: Search roles
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
      - T1UAR_M
    post:
      description: Creates a new role in the system with the provided details
      operationId: create
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakRole'
        description: The details of the role to be created
        required: true
      responses:
        "201":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Role'
          description: Successfully created the role
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "409":
          description: "Conflict: role already exists"
      security:
      - oauth2AuthCode: []
      summary: Create a new role
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
  /roles/{roleId}/identityAttributes:
    delete:
      description: Removes an identity attribute from a specified role
      operationId: deleteAttributeFromRole
      parameters:
      - description: The UUID of the role
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      - description: The code of the attribute to be removed
        explode: true
        in: query
        name: attributeCode
        required: true
        schema:
          type: string
        style: form
      responses:
        "204":
          description: Successfully removed the attribute from the role
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2AuthCode: []
      summary: Delete an identity attribute from a role
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
      - T1UAR_M
    put:
      description: Assigns a list of identity attribute IDs to a specified role
      operationId: replaceIdentityAttributes
      parameters:
      - description: The UUID of the role to which identity attributes will be assigned
        example: 123e4567-e89b-12d3-a456-426614174000
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              items:
                type: string
              type: array
        description: List of identity attribute codes to be assigned to the role
        required: true
      responses:
        "200":
          description: Successfully assigned identity attributes
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Role not found
      security:
      - oauth2AuthCode: []
      summary: Assign identity attributes to a role
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
  /roles/{roleId}/identityAttributes/duplicate:
    post:
      description: Duplicates identity attributes from the source role to the destination
        role
      operationId: duplicateIdentityAttributeToAnOtherRole
      parameters:
      - description: The UUID of the source role
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              type: string
        description: The UUID of the destination role
        required: true
      responses:
        "200":
          description: Successfully duplicated identity attributes
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Source or destination role not found
      security:
      - oauth2AuthCode: []
      summary: Duplicate identity attributes to another role
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
  /users:
    get:
      description: Searches for users based on various filter criteria
      operationId: search
      parameters:
      - explode: true
        in: query
        name: username
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: firstName
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: lastName
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: email
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: first
        required: false
        schema:
          format: int32
          type: integer
        style: form
      - explode: true
        in: query
        name: max
        required: false
        schema:
          format: int32
          type: integer
        style: form
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/KeycloakUser'
                type: array
          description: Successfully retrieved list of users
        "400":
          description: Invalid filter criteria
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2AuthCode: []
      summary: Search users (replaces getUserByEmail)
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
    post:
      description: Creates a user with the provided data
      operationId: createUser
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakUser'
        required: true
      responses:
        "201":
          content:
            application/json:
              schema:
                type: string
          description: Created
      security:
      - oauth2AuthCode: []
      summary: Creates a user
      tags:
      - Users
  /users/import:
    post:
      description: Import the provided users into the system
      operationId: importUsers
      requestBody:
        content:
          application/json:
            schema:
              items:
                $ref: '#/components/schemas/KeycloakUser'
              type: array
        required: true
      responses:
        "201":
          description: Created
      security:
      - oauth2AuthCode: []
      summary: Import the provided users into the system
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
  /users/asT1users:
    post:
      deprecated: true
      description: Creates a new tier-one user
      operationId: createUserAsT1
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakUser'
        description: The user details
        required: true
      responses:
        "201":
          content:
            text/plain:
              schema:
                description: The Id of the newly created user
                example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
                type: string
          description: User created successfully
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "409":
          description: "Conflict: User already exists"
      security:
      - oauth2AuthCode: []
      summary: POST /users will be protected both with scopes and roles
      tags:
      - Users
      x-simpl-roles:
      - T1UAR_M
  /sessions/credentials:
    post:
      deprecated: true
      description: Validate the tier one session against the ephemeral proof stored
        in the agent
      operationId: validateTierOneSession
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TierOneSession'
        required: true
      responses:
        "204":
          description: Tier 1 session validated successfully
        "422":
          description: Invalid Tier 1 session
      security:
      - oauth2ClientCredentials: []
      summary: Validate Tier 1 session
      tags:
      - Sessions
      x-deprecated: Moved to Authentication Provider
  /roles/{roleId}/duplicateIdentityAttributes:
    post:
      deprecated: true
      description: Duplicates identity attributes from the source role to the destination
        role
      operationId: duplicateIdentityAttributeToAnOtherRoleDeprecated
      parameters:
      - description: The UUID of the source role
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              type: string
        description: The UUID of the destination role
        required: true
      responses:
        "200":
          description: Successfully duplicated identity attributes
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Source or destination role not found
      security:
      - oauth2AuthCode: []
      summary: "Use POST /roles/{roleId}/identityAttributes/duplicate"
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
  /roles/import:
    post:
      description: Import the provided roles into the system
      operationId: importRoles
      requestBody:
        content:
          application/json:
            schema:
              items:
                $ref: '#/components/schemas/KeycloakRole'
              type: array
        required: true
      responses:
        "201":
          description: Created
      security:
      - oauth2AuthCode: []
      summary: Import the provided roles into the system
      tags:
      - Roles
  /roles/assignedIdentityAttributes:
    post:
      deprecated: true
      description: Retrieves a list of identity attributes associated with the provided
        roles
      operationId: getIdentityAttributesFromRoleList
      requestBody:
        content:
          application/json:
            schema:
              items:
                type: string
              type: array
        description: List of role names from which to retrieve identity attributes
        required: true
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  type: string
                type: array
          description: Successfully retrieved identity attributes
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2ClientCredentials: []
      summary: "Use GET /roles/{roleId}"
      tags:
      - Roles
  /mtls/ephemeralProof:
    post:
      deprecated: true
      description: Stores the ephemeral proof for a participant identified by their
        UUID
      operationId: storeCallerEphemeralProof
      parameters:
      - description: The Public Key Hash of the participant
        explode: false
        in: header
        name: Credential-Id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          text/plain:
            schema:
              type: string
        description: The ephemeral proof to be stored
        required: true
      responses:
        "200":
          description: Ephemeral proof successfully stored
        "400":
          description: Invalid input data
        "404":
          description: Participant not found
      security:
      - mtls: []
      summary: Store Ephemeral Proof
      tags:
      - Mtls
      x-deprecated: Moved to Authentication Provider
  /credentials:
    delete:
      description: Deletes the existing credential from the server
      operationId: delete
      responses:
        "204":
          description: Successfully deleted credential
        "404":
          description: Credential not found
      security:
      - oauth2AuthCode: []
      summary: Delete the credential
      tags:
      - Credentials
      x-simpl-roles:
      - ONBOARDER_M
    get:
      deprecated: true
      description: "Returns true if a credential is present, false otherwise"
      operationId: hasCredential
      responses:
        "200":
          content:
            application/json:
              schema:
                description: Boolean indicating if a credential is present
                example: true
                type: boolean
          description: Successfully checked credential presence
      security:
      - oauth2AuthCode: []
      summary: Check if a credential is present
      tags:
      - Credentials
      x-deprecated: Moved to Authentication Provider
    post:
      deprecated: true
      description: Uploads a credential file to the server and returns the ID of the
        uploaded credential
      operationId: uploadCredential
      requestBody:
        content:
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/uploadCredential_request'
      responses:
        "201":
          content:
            application/json:
              schema:
                description: The id of the uploaded credential
                example: 12345
                type: integer
          description: Successfully uploaded credential
        "400":
          description: Invalid file format
      security:
      - oauth2AuthCode: []
      summary: Upload a credential file
      tags:
      - Credentials
      x-deprecated: Moved to Authentication Provider
      x-simpl-roles:
      - ONBOARDER_M
  /sessions/{credentialId}:
    get:
      deprecated: true
      description: Fetches the identity attributes associated with the specified participant
        ID
      operationId: getIdentityAttributesOfParticipant
      parameters:
      - description: The Public Key Hash of the participant
        explode: false
        in: path
        name: credentialId
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/IdentityAttribute'
                type: array
          description: Successfully retrieved identity attributes
        "404":
          description: Ephemeral proof not found
      security:
      - oauth2ClientCredentials: []
      summary: Retrieve identity attributes of a participant
      tags:
      - Sessions
      x-deprecated: Moved to Authentication Provider
  /mtls/ping:
    get:
      deprecated: true
      description: Performs a ping operation to check the participant's status using
        its credential id
      operationId: ping
      parameters:
      - description: The Public Key Hash of the participant
        explode: false
        in: header
        name: Credential-Id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ParticipantWithIdentityAttributes'
          description: Successfully pinged the participant
        "404":
          description: Participant not found
      security:
      - mtls: []
      summary: Ping the participant
      tags:
      - Mtls
      x-deprecated: Moved to Authentication Provider
  /identityAttributes:
    get:
      deprecated: true
      description: Searches for identity attributes with ownership based on the provided
        filter and pagination settings
      operationId: searchIdentityAttributesWithOwnership
      parameters:
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 10
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          default:
          - "id,ASC"
          items:
            type: string
          type: array
        style: form
      - in: query
        name: filter
        schema:
          $ref: '#/components/schemas/searchIdentityAttributesWithOwnership_filter_parameter'
        x-parameter-object: true
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PagedModelIdentityAttributeWithOwnership'
          description: Successfully retrieved the identity attributes
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2AuthCode: []
      summary: Search identity attributes with ownership
      tags:
      - Identity Attributes
      x-deprecated: Moved to Authentication Provider
      x-simpl-roles:
      - T1UAR_M
      - NOTARY
      - IATTR_M
      - NOTARY
  /identityAttributes/updateAssignments:
    put:
      description: Enables a list of identity attribute codes received in the request
        body as a JSON array of strings. Each provided ID is activated.
      operationId: updateAssignmentsIdentityAttributeRoles
      requestBody:
        content:
          application/json:
            schema:
              items:
                type: string
              type: array
        description: List of identity attribute codes
        required: true
      responses:
        "204":
          description: Successfully update identity attributes
        "401":
          description: Access denied
      summary: Update Assignments Identity Attribute Roles Service
      tags:
      - Identity Attributes
  /credentials/publicKey:
    get:
      deprecated: true
      description: Fetches the public key associated with the stored credential
      operationId: getPublicKey
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Credential'
          description: Successfully retrieved public key
        "404":
          description: Credential not found
      summary: Retrieve the public key
      tags:
      - Credentials
      x-deprecated: Moved to Authentication Provider
  /credentials/myId:
    get:
      deprecated: true
      description: Fetches the participant ID associated with the current participant
      operationId: getMyParticipantId
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Participant'
          description: Successfully retrieved participant ID
        "404":
          description: Credential not found
      security:
      - oauth2ClientCredentials: []
      summary: Retrieve participant ID
      tags:
      - Credentials
      x-deprecated: Moved to Authentication Provider
  /credentials/download:
    get:
      deprecated: true
      description: Download participant's credential
      operationId: downloadInstalledCredentials
      responses:
        "200":
          content:
            application/octet-stream:
              schema:
                format: stream
                type: string
          description: OK
      security:
      - oauth2AuthCode: []
      summary: Download participant's credential
      tags:
      - Credentials
      x-deprecated: Moved to Authentication Provider
  /credentials/credentialId:
    get:
      deprecated: true
      description: Fetches the credential ID associated with the current participant
      operationId: getCredentialId
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Participant'
          description: Successfully retrieved credential ID
        "404":
          description: Credential not found
      security:
      - oauth2ClientCredentials: []
      summary: Retrieve credential ID
      tags:
      - Credentials
      x-deprecated: Moved to Authentication Provider
  /agent/ping:
    get:
      deprecated: true
      description: Pings a participant using the provided FQDN and returns identity
        attributes
      operationId: pingAgent
      parameters:
      - description: Fully Qualified Domain Name of the participant
        explode: true
        in: query
        name: fqdn
        required: true
        schema:
          type: string
        style: form
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ParticipantWithIdentityAttributes'
          description: Successfully pinged the participant
        "400":
          description: Invalid FQDN provided
      security:
      - oauth2AuthCode: []
      summary: Ping a participant
      tags:
      - Agents
      x-deprecated: Moved to Authentication Provider
  /agent/identityAttributes:
    get:
      deprecated: true
      description: Returns a list of identity attributes with ownership details
      operationId: getIdentityAttributesWithOwnership
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/IdentityAttributeWithOwnership'
                type: array
          description: Successfully retrieved identity attributes with ownership
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2AuthCode: []
      summary: Get identity attributes with ownership
      tags:
      - Agents
      x-deprecated: Moved to Authentication Provider
      x-simpl-roles:
      - T1UAR_M
  /agent/identityAttributes/{credentialId}:
    get:
      deprecated: true
      description: Returns a list of identity attributes with ownership details
      operationId: getParticipantIdentityAttributes
      parameters:
      - description: The certificate ID of the participant
        explode: true
        in: query
        name: certificateId
        required: true
        schema:
          type: string
        style: form
      - explode: false
        in: path
        name: credentialId
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/IdentityAttribute'
                type: array
          description: Successfully retrieved identity attributes with ownership
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2AuthCode: []
      summary: Get identity attributes with ownership
      tags:
      - Agents
      x-deprecated: Moved to Authentication Provider
      x-simpl-roles:
      - T1UAR_M
  /agent/echo:
    get:
      deprecated: true
      description: Returns echo information including connection and MTLS status
      operationId: echo
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Echo'
          description: Successfully retrieved echo information
      security:
      - oauth2AuthCode: []
      summary: Get echo information
      tags:
      - Agents
      x-deprecated: Moved to Authentication Provider
  /sessions/current:
    delete:
      deprecated: true
      description: End the session for the current user
      operationId: deleteCurrentSession
      responses:
        "204":
          description: Successfully deleted user session
        "400":
          description: Communication error with Keycloak admin
      security:
      - oauth2AuthCode: []
      summary: Current User Logout
      tags:
      - Sessions
      x-deprecated: Moved to Authentication Provider
  /roles/{roleId}:
    delete:
      description: Removes a role from the system using its id
      operationId: deleteCredential
      parameters:
      - description: The name of the role to be deleted
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      responses:
        "204":
          description: Successfully deleted the role
        "400":
          description: Invalid role name
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Role not found
      security:
      - oauth2AuthCode: []
      summary: Delete a role by id
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
    get:
      description: Retrieves a role by its unique identifier (UUID)
      operationId: findById
      parameters:
      - description: The UUID of the role
        example: 123e4567-e89b-12d3-a456-426614174000
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Role'
          description: Successfully retrieved the role
        "400":
          description: Invalid UUID format
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Role not found
      security:
      - oauth2AuthCode: []
      summary: Find role by ID
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
    put:
      description: Updates the details of an existing role in the system
      operationId: update
      parameters:
      - description: The UUID of the role
        example: 123e4567-e89b-12d3-a456-426614174000
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Role'
        description: The details of the role to be updated
        required: true
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Role'
          description: Successfully updated the role
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: Cannot modify role's name or User does not have\
            \ the required role"
        "404":
          description: Role not found
        "409":
          description: Conflict
      security:
      - oauth2AuthCode: []
      summary: Update an existing role
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
  /roles/deleteAttributes:
    delete:
      deprecated: true
      description: Removes an identity attribute from a specified role
      operationId: deleteAttributeFromRoleDeprecated
      parameters:
      - description: The UUID of the role from which the attribute will be removed
        explode: true
        in: query
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: form
      - description: The code of the attribute to be removed
        explode: true
        in: query
        name: attributeCode
        required: true
        schema:
          type: string
        style: form
      responses:
        "204":
          description: Successfully removed the attribute from the role
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      security:
      - oauth2AuthCode: []
      summary: Delete an identity attribute from a role
      tags:
      - Roles
      x-simpl-roles:
      - T1UAR_M
      - T1UAR_M
  /signPublicKeys:
    get:
      description: "This endpoint allows retrieving the public key by contacting the\
        \ Identity and Access Manager server. \nThe service queries the server, filters\
        \ the available keys using the attribute \"use\": \"sig\", \nand returns the\
        \ corresponding public key.\n"
      operationId: getSignPublicKey
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PublicKey'
          description: Successfully retrieved public key.
        "404":
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: No public key found for sign purpose.
      summary: Retrieves the public key associated with a sign purpose from the Identity
        and Access Manager server.
      tags:
      - Public Keys
components:
  schemas:
    PageMetadata:
      example:
        number: 6
        size: 0
        totalPages: 5
        totalElements: 1
      properties:
        size:
          format: int64
          type: integer
        number:
          format: int64
          type: integer
        totalElements:
          format: int64
          type: integer
        totalPages:
          format: int64
          type: integer
      type: object
    Credential:
      example:
        publicKey: publicKey
      properties:
        publicKey:
          type: string
      type: object
    PagedModelIdentityAttributeWithOwnership:
      example:
        page:
          number: 6
          size: 0
          totalPages: 5
          totalElements: 1
        content:
        - code: code
          assignedToParticipant: true
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        - code: code
          assignedToParticipant: true
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        content:
          items:
            $ref: '#/components/schemas/IdentityAttributeWithOwnership'
          type: array
        page:
          $ref: '#/components/schemas/PageMetadata'
      type: object
    KeycloakUser:
      example:
        firstName: firstName
        lastName: lastName
        password: password
        roles:
        - roles
        - roles
        id: id
        email: email
        username: username
      properties:
        id:
          readOnly: true
          type: string
        username:
          type: string
        firstName:
          type: string
        lastName:
          type: string
        email:
          type: string
        password:
          type: string
        roles:
          items:
            type: string
          type: array
      required:
      - email
      - firstName
      - lastName
      - password
      - username
      type: object
    StreamingResponseBody:
      type: object
    Echo:
      example:
        mtlsStatus: SECURED
        participantType: participantType
        userIdentityAttributes:
        - userIdentityAttributes
        - userIdentityAttributes
        identityAttributes:
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
        expiryDate: 2000-01-23T04:56:07.000+00:00
        organization: organization
        connectionStatus: CONNECTED
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        credentialId: credentialId
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        email: email
        username: username
      properties:
        username:
          type: string
        email:
          type: string
        connectionStatus:
          $ref: '#/components/schemas/ConnectionStatus'
        mtlsStatus:
          $ref: '#/components/schemas/MTLSStatus'
        userIdentityAttributes:
          items:
            type: string
          type: array
        id:
          format: uuid
          type: string
        participantType:
          type: string
        organization:
          type: string
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        credentialId:
          type: string
        expiryDate:
          format: date-time
          type: string
        identityAttributes:
          items:
            $ref: '#/components/schemas/IdentityAttribute'
          type: array
      required:
      - organization
      - participantType
      type: object
    IdentityAttributeWithOwnership:
      example:
        code: code
        assignedToParticipant: true
        name: name
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        description: description
        assignableToRoles: true
        participantTypes:
        - participantTypes
        - participantTypes
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        used: true
        enabled: true
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        code:
          type: string
        name:
          type: string
        description:
          type: string
        assignableToRoles:
          type: boolean
        enabled:
          type: boolean
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        participantTypes:
          items:
            type: string
          type: array
          uniqueItems: true
        used:
          readOnly: true
          type: boolean
        assignedToParticipant:
          type: boolean
      required:
      - assignableToRoles
      - code
      - enabled
      - name
      type: object
    Error:
      properties:
        error:
          type: string
        elementName:
          type: string
      type: object
    IdentityAttribute:
      example:
        code: code
        name: name
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        description: description
        assignableToRoles: true
        participantTypes:
        - participantTypes
        - participantTypes
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        used: true
        enabled: true
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        code:
          type: string
        name:
          type: string
        description:
          type: string
        assignableToRoles:
          type: boolean
        enabled:
          type: boolean
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        participantTypes:
          items:
            type: string
          type: array
          uniqueItems: true
        used:
          readOnly: true
          type: boolean
      required:
      - assignableToRoles
      - code
      - enabled
      - name
      type: object
    Role:
      example:
        assignedIdentityAttributes:
        - assignedIdentityAttributes
        - assignedIdentityAttributes
        name: name
        description: description
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
      properties:
        id:
          format: uuid
          type: string
        name:
          type: string
        description:
          type: string
        assignedIdentityAttributes:
          items:
            type: string
          type: array
      required:
      - id
      - name
      type: object
    KeycloakRole:
      example:
        name: name
        description: description
      properties:
        name:
          type: string
        description:
          type: string
      required:
      - name
      type: object
    TierOneSession:
      example:
        jwt: jwt
      properties:
        jwt:
          type: string
      required:
      - jwt
      type: object
    Participant:
      example:
        expiryDate: 2000-01-23T04:56:07.000+00:00
        organization: organization
        participantType: participantType
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        credentialId: credentialId
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        participantType:
          type: string
        organization:
          type: string
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        credentialId:
          type: string
        expiryDate:
          format: date-time
          type: string
      required:
      - organization
      - participantType
      type: object
    ConnectionStatus:
      enum:
      - CONNECTED
      - NOT_CONNECTED
      type: string
    MTLSStatus:
      enum:
      - SECURED
      - NOT_SECURED
      type: string
    ParticipantWithIdentityAttributes:
      example:
        expiryDate: 2000-01-23T04:56:07.000+00:00
        organization: organization
        participantType: participantType
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        credentialId: credentialId
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        identityAttributes:
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        participantType:
          type: string
        organization:
          type: string
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        credentialId:
          type: string
        expiryDate:
          format: date-time
          type: string
        identityAttributes:
          items:
            $ref: '#/components/schemas/IdentityAttribute'
          type: array
      required:
      - organization
      - participantType
      type: object
    PageResponseRole:
      example:
        page:
          number: 6
          size: 0
          totalPages: 5
          totalElements: 1
        content:
        - assignedIdentityAttributes:
          - assignedIdentityAttributes
          - assignedIdentityAttributes
          name: name
          description: description
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        - assignedIdentityAttributes:
          - assignedIdentityAttributes
          - assignedIdentityAttributes
          name: name
          description: description
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        empty: true
      properties:
        content:
          items:
            $ref: '#/components/schemas/Role'
          type: array
        page:
          $ref: '#/components/schemas/PageMetadata'
        empty:
          type: boolean
      type: object
    PublicKey:
      example:
        publicKey: publicKey
      properties:
        publicKey:
          type: string
      type: object
    ProblemDetail:
      properties:
        type:
          format: uri
          type: string
        title:
          type: string
        status:
          format: int32
          type: integer
        detail:
          type: string
        instance:
          format: uri
          type: string
        properties:
          additionalProperties:
            type: object
          type: object
      type: object
    searchRoles_filter_parameter:
      properties:
        name:
          type: string
        description:
          type: string
        attributeName:
          type: string
      type: object
    uploadCredential_request:
      properties:
        credential:
          format: binary
          type: string
      required:
      - credential
      type: object
    searchIdentityAttributesWithOwnership_filter_parameter:
      properties:
        code:
          type: string
        participantTypeIn:
          type: string
        updateTimestampFrom:
          format: date-time
          type: string
        assignedToParticipant:
          type: boolean
        name:
          type: string
        updateTimestampTo:
          format: date-time
          type: string
        enabled:
          type: boolean
        participantTypeNotIn:
          type: string
      type: object
  securitySchemes:
    mtls:
      description: SIMPL mTLS
      scheme: http
      type: http
    oauth2AuthCode:
      flows:
        authorizationCode:
          authorizationUrl: ""
          scopes: {}
          tokenUrl: ""
      type: oauth2
    oauth2ClientCredentials:
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: ""
      type: oauth2
